blob: bde3aaceb9a8040e7dc34039f2ec94ffdc53a967 [file] [log] [blame]
jeffhao5d1ac922011-09-29 17:41:15 -07001#!/bin/bash
2#
3# Copyright (C) 2007 The Android Open Source Project
4#
5# Licensed under the Apache License, Version 2.0 (the "License");
6# you may not use this file except in compliance with the License.
7# You may obtain a copy of the License at
8#
9# http://www.apache.org/licenses/LICENSE-2.0
10#
11# Unless required by applicable law or agreed to in writing, software
12# distributed under the License is distributed on an "AS IS" BASIS,
13# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
14# See the License for the specific language governing permissions and
15# limitations under the License.
16
17# Set up prog to be the path of this script, including following symlinks,
18# and set up progdir to be the fully-qualified pathname of its directory.
19prog="$0"
Andreas Gampedeb48a02014-10-22 00:44:35 -070020args="$@"
jeffhao5d1ac922011-09-29 17:41:15 -070021while [ -h "${prog}" ]; do
22 newProg=`/bin/ls -ld "${prog}"`
23 newProg=`expr "${newProg}" : ".* -> \(.*\)$"`
24 if expr "x${newProg}" : 'x/' >/dev/null; then
25 prog="${newProg}"
26 else
27 progdir=`dirname "${prog}"`
28 prog="${progdir}/${newProg}"
29 fi
30done
31oldwd=`pwd`
32progdir=`dirname "${prog}"`
33cd "${progdir}"
34progdir=`pwd`
35prog="${progdir}"/`basename "${prog}"`
Brian Carlstrom105215d2012-06-14 12:50:44 -070036test_dir="test-$$"
Andreas Gampe5a79fde2014-08-06 13:12:26 -070037if [ -z "$TMPDIR" ]; then
38 tmp_dir="/tmp/$USER/${test_dir}"
39else
Andreas Gampe34a8a0f2016-07-20 21:09:29 -070040 tmp_dir="${TMPDIR}/${test_dir}"
Andreas Gampe5a79fde2014-08-06 13:12:26 -070041fi
David Brazdil2c27f2c2015-05-12 18:06:38 +010042checker="${progdir}/../tools/checker/checker.py"
jeffhao5d1ac922011-09-29 17:41:15 -070043export JAVA="java"
Alex Lightea1e7702016-07-11 13:39:55 -070044export JAVAC="javac -g -Xlint:-options"
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +010045export RUN="${progdir}/etc/run-test-jar"
Brian Carlstrom105215d2012-06-14 12:50:44 -070046export DEX_LOCATION=/data/run-test/${test_dir}
Elliott Hughesc717eef2012-06-15 16:01:26 -070047export NEED_DEX="true"
Alan Leung0afa07a2017-10-03 16:56:30 -070048export USE_D8="false"
Colin Crosse0ef0a82017-07-27 21:29:18 +000049export USE_JACK="false"
Igor Murashkin2a337752017-06-16 14:34:40 +000050export USE_DESUGAR="true"
Ben Gruver14fc9db2017-04-28 15:30:49 -070051export SMALI_ARGS=""
jeffhao5d1ac922011-09-29 17:41:15 -070052
Tsu Chiang Chuang4407e612012-07-19 16:13:43 -070053# If dx was not set by the environment variable, assume it is in the path.
54if [ -z "$DX" ]; then
55 export DX="dx"
56fi
57
Tsu Chiang Chuang6674f8a2013-01-16 15:41:21 -080058# If jasmin was not set by the environment variable, assume it is in the path.
59if [ -z "$JASMIN" ]; then
60 export JASMIN="jasmin"
61fi
62
Andreas Gampe8fda9f22014-10-03 16:15:37 -070063# If smali was not set by the environment variable, assume it is in the path.
64if [ -z "$SMALI" ]; then
65 export SMALI="smali"
66fi
67
68# If dexmerger was not set by the environment variable, assume it is in the path.
69if [ -z "$DXMERGER" ]; then
70 export DXMERGER="dexmerger"
71fi
72
Sebastien Hertz19ac0272015-02-24 17:39:50 +010073# If jack was not set by the environment variable, assume it is in the path.
74if [ -z "$JACK" ]; then
75 export JACK="jack"
76fi
77
Sebastien Hertz19ac0272015-02-24 17:39:50 +010078# ANDROID_BUILD_TOP is not set in a build environment.
79if [ -z "$ANDROID_BUILD_TOP" ]; then
80 export ANDROID_BUILD_TOP=$oldwd
81fi
82
Andreas Gampef47fb2f2016-06-24 22:30:29 -070083# ANDROID_HOST_OUT is not set in a build environment.
84if [ -z "$ANDROID_HOST_OUT" ]; then
Dan Willemsenf325e012017-03-03 12:35:30 -080085 export ANDROID_HOST_OUT=${OUT_DIR:-$ANDROID_BUILD_TOP/out}/host/linux-x86
Andreas Gampef47fb2f2016-06-24 22:30:29 -070086fi
87
Sebastien Hertz19ac0272015-02-24 17:39:50 +010088# If JACK_CLASSPATH is not set, assume it only contains core-libart.
89if [ -z "$JACK_CLASSPATH" ]; then
Andreas Gampef47fb2f2016-06-24 22:30:29 -070090 export JACK_CLASSPATH="${ANDROID_HOST_OUT}/../common/obj/JAVA_LIBRARIES/core-libart-hostdex_intermediates/classes.jack:${ANDROID_HOST_OUT}/../common/obj/JAVA_LIBRARIES/core-oj-hostdex_intermediates/classes.jack"
Sebastien Hertz19ac0272015-02-24 17:39:50 +010091fi
92
Sebastien Hertz19ac0272015-02-24 17:39:50 +010093export JACK="$JACK -g -cp $JACK_CLASSPATH"
Tsu Chiang Chuang6674f8a2013-01-16 15:41:21 -080094
Igor Murashkine5181932017-06-15 16:03:50 -070095# Allow changing DESUGAR script to something else, or to disable it with DESUGAR=false.
Igor Murashkind3232772017-06-22 14:54:13 -070096if [ -z "$DESUGAR" ]; then
Igor Murashkine5181932017-06-15 16:03:50 -070097 export DESUGAR="$ANDROID_BUILD_TOP/art/tools/desugar.sh"
98fi
99
Igor Murashkin271a0f82017-02-14 21:14:17 +0000100# Zipalign is not on the PATH in some configs, auto-detect it.
101if [ -z "$ZIPALIGN" ]; then
102 if which zipalign >/dev/null; then
103 ZIPALIGN="zipalign";
104 else
105 # TODO: Add a dependency for zipalign in Android.run-test.mk
106 # once it doesn't depend on libandroidfw (b/35246701)
107 case "$OSTYPE" in
108 darwin*) ZIPALIGN="$ANDROID_BUILD_TOP/prebuilts/sdk/tools/darwin/bin/zipalign" ;;
109 linux*) ZIPALIGN="$ANDROID_BUILD_TOP/prebuilts/sdk/tools/linux/bin/zipalign" ;;
110 *) echo "Can't find zipalign: unknown: $OSTYPE" >&2;;
111 esac
112 fi
113fi
114export ZIPALIGN
115
David Brazdil11b67b22018-01-18 16:41:40 +0000116# If hiddenapi was not set by the environment variable, assume it is in the path.
117if [ -z "$HIDDENAPI" ]; then
118 export HIDDENAPI="hiddenapi"
119fi
120
jeffhao5d1ac922011-09-29 17:41:15 -0700121info="info.txt"
122build="build"
123run="run"
124expected="expected.txt"
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700125check_cmd="check"
jeffhao5d1ac922011-09-29 17:41:15 -0700126output="output.txt"
127build_output="build-output.txt"
David Brazdil24128c62015-05-21 12:06:13 +0100128cfg_output="graph.cfg"
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700129strace_output="strace-output.txt"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700130lib="libartd.so"
Mathieu Chartier031768a2015-08-27 10:25:02 -0700131testlib="arttestd"
jeffhao5d1ac922011-09-29 17:41:15 -0700132run_args="--quiet"
David Brazdil4846d132015-01-15 19:07:08 +0000133build_args=""
jeffhao5d1ac922011-09-29 17:41:15 -0700134
Alex Light91de25f2015-10-28 17:00:06 -0700135quiet="no"
Nicolas Geoffraya3d90fb2015-03-16 13:55:40 +0000136debuggable="no"
Alex Light9d722532014-07-22 18:07:12 -0700137prebuild_mode="yes"
Brian Carlstrom2613de42012-06-15 17:37:16 -0700138target_mode="yes"
jeffhao5d1ac922011-09-29 17:41:15 -0700139dev_mode="no"
140update_mode="no"
Alex Lighta59dd802014-07-02 16:28:08 -0700141debug_mode="no"
Nicolas Geoffray94e25db2017-01-27 14:54:28 +0000142relocate="no"
Jeff Hao201803f2013-11-20 18:11:39 -0800143runtime="art"
jeffhao5d1ac922011-09-29 17:41:15 -0700144usage="no"
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700145build_only="no"
Andreas Gampe2fe07922014-04-21 07:50:39 -0700146suffix64=""
Jeff Hao85139a32014-07-23 11:52:52 -0700147trace="false"
Andreas Gampe7526d782015-06-22 22:53:45 -0700148trace_stream="false"
Alex Lighte7873ec2014-08-12 09:53:50 -0700149basic_verify="false"
150gc_verify="false"
151gc_stress="false"
Alex Lightb7edcda2017-04-27 13:20:31 -0700152jvmti_trace_stress="false"
Alex Light43e935d2017-06-19 15:40:40 -0700153jvmti_field_stress="false"
Alex Lightc38c3692017-06-27 15:45:14 -0700154jvmti_step_stress="false"
Alex Lightb7edcda2017-04-27 13:20:31 -0700155jvmti_redefine_stress="false"
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700156strace="false"
Alex Lightbfac14a2014-07-30 09:41:21 -0700157always_clean="no"
Igor Murashkin05f30e12015-06-10 15:57:17 -0700158never_clean="no"
Alex Light03a112d2014-08-25 13:25:56 -0700159have_dex2oat="yes"
160have_patchoat="yes"
161have_image="yes"
Jeff Haodcdc85b2015-12-04 14:06:18 -0800162multi_image_suffix=""
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000163android_root="/system"
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700164bisection_search="no"
Mathieu Chartier3fceaf52017-01-22 13:33:40 -0800165suspend_timeout="500000"
Alex Light10bc5a42016-05-10 10:01:22 -0700166# By default we will use optimizing.
167image_args=""
Nicolas Geoffrayb76bc782016-09-14 12:33:34 +0000168image_suffix=""
jeffhao5d1ac922011-09-29 17:41:15 -0700169
170while true; do
171 if [ "x$1" = "x--host" ]; then
Brian Carlstrom2613de42012-06-15 17:37:16 -0700172 target_mode="no"
TDYa127b92bcab2012-04-08 00:09:51 -0700173 DEX_LOCATION=$tmp_dir
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100174 run_args="${run_args} --host"
jeffhao5d1ac922011-09-29 17:41:15 -0700175 shift
Alex Light91de25f2015-10-28 17:00:06 -0700176 elif [ "x$1" = "x--quiet" ]; then
177 quiet="yes"
178 shift
Alex Lighteb7c1442015-08-31 13:17:42 -0700179 elif [ "x$1" = "x--use-java-home" ]; then
180 if [ -n "${JAVA_HOME}" ]; then
181 export JAVA="${JAVA_HOME}/bin/java"
182 export JAVAC="${JAVA_HOME}/bin/javac -g"
183 else
184 echo "Passed --use-java-home without JAVA_HOME variable set!"
185 usage="yes"
186 fi
187 shift
Elliott Hughes58bcc402012-02-14 14:10:10 -0800188 elif [ "x$1" = "x--jvm" ]; then
Brian Carlstrom2613de42012-06-15 17:37:16 -0700189 target_mode="no"
Alex Light2c7aaeb2017-01-27 14:08:17 -0800190 DEX_LOCATION="$tmp_dir"
Jeff Hao201803f2013-11-20 18:11:39 -0800191 runtime="jvm"
Alex Lightbc90d0f2016-05-09 16:21:09 -0700192 image_args=""
Brian Carlstrom01afdba2014-10-03 10:28:47 -0700193 prebuild_mode="no"
Elliott Hughesc717eef2012-06-15 16:01:26 -0700194 NEED_DEX="false"
Sebastien Hertz19ac0272015-02-24 17:39:50 +0100195 USE_JACK="false"
Nicolas Geoffray288a4a22014-10-07 11:02:40 +0100196 run_args="${run_args} --jvm"
Alex Lighteb7c1442015-08-31 13:17:42 -0700197 build_args="${build_args} --jvm"
jeffhao5d1ac922011-09-29 17:41:15 -0700198 shift
Elliott Hughes58bcc402012-02-14 14:10:10 -0800199 elif [ "x$1" = "x-O" ]; then
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700200 lib="libart.so"
Mathieu Chartier031768a2015-08-27 10:25:02 -0700201 testlib="arttest"
Alex Lightfaf90b62016-08-12 14:43:48 -0700202 run_args="${run_args} -O"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700203 shift
204 elif [ "x$1" = "x--dalvik" ]; then
205 lib="libdvm.so"
Jeff Hao201803f2013-11-20 18:11:39 -0800206 runtime="dalvik"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700207 shift
Alex Light03a112d2014-08-25 13:25:56 -0700208 elif [ "x$1" = "x--no-dex2oat" ]; then
209 have_dex2oat="no"
210 shift
211 elif [ "x$1" = "x--no-patchoat" ]; then
212 have_patchoat="no"
213 shift
214 elif [ "x$1" = "x--no-image" ]; then
215 have_image="no"
216 shift
Jeff Haodcdc85b2015-12-04 14:06:18 -0800217 elif [ "x$1" = "x--multi-image" ]; then
218 multi_image_suffix="-multi"
219 shift
Andreas Gampec23c9c92014-10-28 14:47:25 -0700220 elif [ "x$1" = "x--pic-test" ]; then
221 run_args="${run_args} --pic-test"
222 shift
Alex Lighta59dd802014-07-02 16:28:08 -0700223 elif [ "x$1" = "x--relocate" ]; then
224 relocate="yes"
225 shift
226 elif [ "x$1" = "x--no-relocate" ]; then
227 relocate="no"
228 shift
229 elif [ "x$1" = "x--prebuild" ]; then
Nicolas Geoffray5fd18ba2014-10-03 12:08:38 +0100230 run_args="${run_args} --prebuild"
Alex Lighta59dd802014-07-02 16:28:08 -0700231 prebuild_mode="yes"
232 shift;
Mathieu Chartierdcd56c92017-11-20 20:30:24 -0800233 elif [ "x$1" = "x--compact-dex-level" ]; then
234 option="$1"
235 shift
236 run_args="${run_args} $option $1"
237 shift;
Richard Uhler76f5cb62016-04-04 13:30:16 -0700238 elif [ "x$1" = "x--strip-dex" ]; then
239 run_args="${run_args} --strip-dex"
240 shift;
Nicolas Geoffray43c162f2015-03-09 12:21:26 +0000241 elif [ "x$1" = "x--debuggable" ]; then
242 run_args="${run_args} -Xcompiler-option --debuggable"
Nicolas Geoffraya3d90fb2015-03-16 13:55:40 +0000243 debuggable="yes"
Nicolas Geoffray43c162f2015-03-09 12:21:26 +0000244 shift;
Alex Lighta59dd802014-07-02 16:28:08 -0700245 elif [ "x$1" = "x--no-prebuild" ]; then
Nicolas Geoffray5fd18ba2014-10-03 12:08:38 +0100246 run_args="${run_args} --no-prebuild"
Alex Lighta59dd802014-07-02 16:28:08 -0700247 prebuild_mode="no"
248 shift;
Alex Lighte7873ec2014-08-12 09:53:50 -0700249 elif [ "x$1" = "x--gcverify" ]; then
250 basic_verify="true"
251 gc_verify="true"
252 shift
253 elif [ "x$1" = "x--gcstress" ]; then
254 basic_verify="true"
255 gc_stress="true"
256 shift
Alex Lightc38c3692017-06-27 15:45:14 -0700257 elif [ "x$1" = "x--jvmti-step-stress" ]; then
258 jvmti_step_stress="true"
259 shift
Alex Lightb7edcda2017-04-27 13:20:31 -0700260 elif [ "x$1" = "x--jvmti-redefine-stress" ]; then
261 jvmti_redefine_stress="true"
262 shift
Alex Light43e935d2017-06-19 15:40:40 -0700263 elif [ "x$1" = "x--jvmti-field-stress" ]; then
264 jvmti_field_stress="true"
265 shift
Alex Lightb7edcda2017-04-27 13:20:31 -0700266 elif [ "x$1" = "x--jvmti-trace-stress" ]; then
267 jvmti_trace_stress="true"
Alex Light8f2c6d42017-04-10 16:27:35 -0700268 shift
Mathieu Chartier3fceaf52017-01-22 13:33:40 -0800269 elif [ "x$1" = "x--suspend-timeout" ]; then
270 shift
271 suspend_timeout="$1"
272 shift
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700273 elif [ "x$1" = "x--image" ]; then
274 shift
275 image="$1"
276 run_args="${run_args} --image $image"
Elliott Hughes7c046102011-10-19 18:16:03 -0700277 shift
Nicolas Geoffray92cf83e2014-03-18 17:59:20 +0000278 elif [ "x$1" = "x-Xcompiler-option" ]; then
279 shift
280 option="$1"
281 run_args="${run_args} -Xcompiler-option $option"
282 shift
Orion Hodsone1fb77f2017-02-27 13:57:18 +0000283 elif [ "x$1" = "x--build-option" ]; then
284 shift
285 option="$1"
286 build_args="${build_args} $option"
287 shift
Mathieu Chartier769a5ad2014-05-18 15:30:10 -0700288 elif [ "x$1" = "x--runtime-option" ]; then
289 shift
290 option="$1"
291 run_args="${run_args} --runtime-option $option"
292 shift
Mathieu Chartierc0a8a802014-10-17 15:58:01 -0700293 elif [ "x$1" = "x--gdb-arg" ]; then
294 shift
295 gdb_arg="$1"
296 run_args="${run_args} --gdb-arg $gdb_arg"
297 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700298 elif [ "x$1" = "x--debug" ]; then
299 run_args="${run_args} --debug"
300 shift
Alex Lightc281ba52017-10-11 11:35:55 -0700301 elif [ "x$1" = "x--debug-wrap-agent" ]; then
302 run_args="${run_args} --debug-wrap-agent"
303 shift
Alex Light0e151e72017-10-25 10:50:35 -0700304 elif [ "x$1" = "x--with-agent" ]; then
305 shift
306 option="$1"
307 run_args="${run_args} --with-agent $1"
308 shift
Alex Lightc281ba52017-10-11 11:35:55 -0700309 elif [ "x$1" = "x--debug-agent" ]; then
310 shift
311 option="$1"
312 run_args="${run_args} --debug-agent $1"
313 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700314 elif [ "x$1" = "x--gdb" ]; then
315 run_args="${run_args} --gdb"
316 dev_mode="yes"
317 shift
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700318 elif [ "x$1" = "x--strace" ]; then
319 strace="yes"
Mathieu Chartier2576be22016-05-24 10:24:53 -0700320 run_args="${run_args} --timeout 1800 --invoke-with strace --invoke-with -o --invoke-with $tmp_dir/$strace_output"
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700321 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700322 elif [ "x$1" = "x--zygote" ]; then
323 run_args="${run_args} --zygote"
324 shift
jeffhao0dff3f42012-11-20 15:13:43 -0800325 elif [ "x$1" = "x--interpreter" ]; then
Nicolas Geoffray4650c932016-05-10 09:13:13 +0000326 run_args="${run_args} --interpreter"
Andreas Gampe63fc30e2014-10-24 21:58:16 -0700327 image_suffix="-interpreter"
328 shift
Mathieu Chartiere5f13e52015-02-24 09:37:21 -0800329 elif [ "x$1" = "x--jit" ]; then
Alex Light10bc5a42016-05-10 10:01:22 -0700330 image_args="--jit"
Nicolas Geoffrayb76bc782016-09-14 12:33:34 +0000331 image_suffix="-interpreter"
Mathieu Chartiere5f13e52015-02-24 09:37:21 -0800332 shift
Andreas Gampe63fc30e2014-10-24 21:58:16 -0700333 elif [ "x$1" = "x--optimizing" ]; then
Alex Light10bc5a42016-05-10 10:01:22 -0700334 image_args="-Xcompiler-option --compiler-backend=Optimizing"
jeffhao0dff3f42012-11-20 15:13:43 -0800335 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700336 elif [ "x$1" = "x--no-verify" ]; then
Richard Uhlerf4b34872016-04-13 11:03:46 -0700337 run_args="${run_args} --no-verify"
jeffhao5d1ac922011-09-29 17:41:15 -0700338 shift
Igor Murashkin7617abd2015-07-10 18:27:47 -0700339 elif [ "x$1" = "x--verify-soft-fail" ]; then
Alex Light10bc5a42016-05-10 10:01:22 -0700340 image_args="--verify-soft-fail"
Andreas Gampe825570c2015-07-26 10:26:03 -0700341 image_suffix="-interp-ac"
Igor Murashkin7617abd2015-07-10 18:27:47 -0700342 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700343 elif [ "x$1" = "x--no-optimize" ]; then
344 run_args="${run_args} --no-optimize"
345 shift
346 elif [ "x$1" = "x--no-precise" ]; then
347 run_args="${run_args} --no-precise"
348 shift
Elliott Hughes7c046102011-10-19 18:16:03 -0700349 elif [ "x$1" = "x--invoke-with" ]; then
350 shift
351 what="$1"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700352 if [ "x$what" = "x" ]; then
353 echo "$0 missing argument to --invoke-with" 1>&2
354 usage="yes"
355 break
356 fi
Ian Rogers0e033672013-04-19 10:22:46 -0700357 run_args="${run_args} --invoke-with ${what}"
jeffhao5d1ac922011-09-29 17:41:15 -0700358 shift
359 elif [ "x$1" = "x--dev" ]; then
360 run_args="${run_args} --dev"
361 dev_mode="yes"
362 shift
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700363 elif [ "x$1" = "x--build-only" ]; then
364 build_only="yes"
365 shift
Alan Leung0afa07a2017-10-03 16:56:30 -0700366 elif [ "x$1" = "x--build-with-d8" ]; then
367 USE_D8="true"
368 shift
Sebastien Hertz19ac0272015-02-24 17:39:50 +0100369 elif [ "x$1" = "x--build-with-javac-dx" ]; then
370 USE_JACK="false"
371 shift
372 elif [ "x$1" = "x--build-with-jack" ]; then
373 USE_JACK="true"
374 shift
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700375 elif [ "x$1" = "x--output-path" ]; then
376 shift
377 tmp_dir=$1
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700378 if [ "x$tmp_dir" = "x" ]; then
379 echo "$0 missing argument to --output-path" 1>&2
380 usage="yes"
381 break
382 fi
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700383 shift
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000384 elif [ "x$1" = "x--android-root" ]; then
385 shift
386 if [ "x$1" = "x" ]; then
387 echo "$0 missing argument to --android-root" 1>&2
388 usage="yes"
389 break
390 fi
391 android_root="$1"
392 run_args="${run_args} --android-root $1"
393 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700394 elif [ "x$1" = "x--update" ]; then
395 update_mode="yes"
396 shift
397 elif [ "x$1" = "x--help" ]; then
398 usage="yes"
399 shift
Andreas Gampeafbaa1a2014-03-25 18:09:32 -0700400 elif [ "x$1" = "x--64" ]; then
401 run_args="${run_args} --64"
Andreas Gampe2fe07922014-04-21 07:50:39 -0700402 suffix64="64"
Andreas Gampeafbaa1a2014-03-25 18:09:32 -0700403 shift
Sebastien Hertz07aaac82014-07-09 15:59:05 +0200404 elif [ "x$1" = "x--trace" ]; then
Jeff Hao85139a32014-07-23 11:52:52 -0700405 trace="true"
Sebastien Hertz07aaac82014-07-09 15:59:05 +0200406 shift
Andreas Gampe7526d782015-06-22 22:53:45 -0700407 elif [ "x$1" = "x--stream" ]; then
408 trace_stream="true"
409 shift
Alex Lightbfac14a2014-07-30 09:41:21 -0700410 elif [ "x$1" = "x--always-clean" ]; then
411 always_clean="yes"
412 shift
Igor Murashkin05f30e12015-06-10 15:57:17 -0700413 elif [ "x$1" = "x--never-clean" ]; then
414 never_clean="yes"
415 shift
Andreas Gampee21dc3d2014-12-08 16:59:43 -0800416 elif [ "x$1" = "x--dex2oat-swap" ]; then
417 run_args="${run_args} --dex2oat-swap"
418 shift
Andreas Gampe4d2ef332015-08-05 09:24:45 -0700419 elif [ "x$1" = "x--instruction-set-features" ]; then
420 shift
421 run_args="${run_args} --instruction-set-features $1"
422 shift
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700423 elif [ "x$1" = "x--bisection-search" ]; then
424 bisection_search="yes"
425 shift
Nicolas Geoffrayb0bbe8e2016-11-19 10:42:37 +0000426 elif [ "x$1" = "x--vdex" ]; then
427 run_args="${run_args} --vdex"
428 shift
Nicolas Geoffray74981052017-01-16 17:54:09 +0000429 elif [ "x$1" = "x--vdex-filter" ]; then
430 shift
431 filter=$1
432 run_args="${run_args} --vdex-filter $filter"
433 shift
Jeff Hao002b9312017-03-27 16:23:08 -0700434 elif [ "x$1" = "x--random-profile" ]; then
435 run_args="${run_args} --random-profile"
436 shift
Shubham Ajmera981d99c2017-08-17 14:11:08 -0700437 elif [ "x$1" = "x--dex2oat-jobs" ]; then
438 shift
439 run_args="${run_args} -Xcompiler-option -j$1"
440 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700441 elif expr "x$1" : "x--" >/dev/null 2>&1; then
Elliott Hughes7c046102011-10-19 18:16:03 -0700442 echo "unknown $0 option: $1" 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700443 usage="yes"
444 break
445 else
446 break
447 fi
448done
Andreas Gampe3a12cfe2014-08-13 15:40:22 -0700449
Alex Light10bc5a42016-05-10 10:01:22 -0700450run_args="${run_args} ${image_args}"
Alex Light91de25f2015-10-28 17:00:06 -0700451# Allocate file descriptor real_stderr and redirect it to the shell's error
452# output (fd 2).
453if [ ${BASH_VERSINFO[1]} -ge 4 ] && [ ${BASH_VERSINFO[2]} -ge 1 ]; then
454 exec {real_stderr}>&2
455else
456 # In bash before version 4.1 we need to do a manual search for free file
457 # descriptors.
458 FD=3
459 while [ -e /dev/fd/$FD ]; do FD=$((FD + 1)); done
460 real_stderr=$FD
461 eval "exec ${real_stderr}>&2"
462fi
463if [ "$quiet" = "yes" ]; then
464 # Force the default standard output and error to go to /dev/null so we will
465 # not print them.
466 exec 1>/dev/null
467 exec 2>/dev/null
468fi
469
470function err_echo() {
471 echo "$@" 1>&${real_stderr}
472}
473
Andreas Gampe3a12cfe2014-08-13 15:40:22 -0700474# tmp_dir may be relative, resolve.
475#
476# Cannot use realpath, as it does not exist on Mac.
477# Cannot us a simple "cd", as the path might not be created yet.
Brian Carlstromc580e042014-09-08 21:37:39 -0700478# Cannot use readlink -m, as it does not exist on Mac.
479# Fallback to nuclear option:
Andreas Gampe907b6992014-08-18 22:26:49 -0700480noncanonical_tmp_dir=$tmp_dir
Brian Carlstromc580e042014-09-08 21:37:39 -0700481tmp_dir="`cd $oldwd ; python -c "import os; print os.path.realpath('$tmp_dir')"`"
Dmitry Petrochenko81c56e72014-03-05 15:05:46 +0700482mkdir -p $tmp_dir
jeffhao5d1ac922011-09-29 17:41:15 -0700483
Mathieu Chartier3fceaf52017-01-22 13:33:40 -0800484# Add thread suspend timeout flag
Narayan Kamathf86c3932017-01-24 17:40:47 +0000485if [ ! "$runtime" = "jvm" ]; then
486 run_args="${run_args} --runtime-option -XX:ThreadSuspendTimeout=$suspend_timeout"
487fi
Mathieu Chartier3fceaf52017-01-22 13:33:40 -0800488
Alex Lighte7873ec2014-08-12 09:53:50 -0700489if [ "$basic_verify" = "true" ]; then
Hiroshi Yamauchi312baf12015-01-12 12:11:05 -0800490 # Set HspaceCompactForOOMMinIntervalMs to zero to run hspace compaction for OOM more frequently in tests.
491 run_args="${run_args} --runtime-option -Xgc:preverify --runtime-option -Xgc:postverify --runtime-option -XX:HspaceCompactForOOMMinIntervalMs=0"
Alex Lighte7873ec2014-08-12 09:53:50 -0700492fi
493if [ "$gc_verify" = "true" ]; then
494 run_args="${run_args} --runtime-option -Xgc:preverify_rosalloc --runtime-option -Xgc:postverify_rosalloc"
495fi
496if [ "$gc_stress" = "true" ]; then
Mathieu Chartierd9eb2842016-08-12 16:11:24 -0700497 run_args="${run_args} --gc-stress --runtime-option -Xgc:gcstress --runtime-option -Xms2m --runtime-option -Xmx16m"
Alex Lighte7873ec2014-08-12 09:53:50 -0700498fi
Alex Lightb7edcda2017-04-27 13:20:31 -0700499if [ "$jvmti_redefine_stress" = "true" ]; then
500 run_args="${run_args} --no-app-image --jvmti-redefine-stress"
501fi
Alex Lightc38c3692017-06-27 15:45:14 -0700502if [ "$jvmti_step_stress" = "true" ]; then
503 run_args="${run_args} --no-app-image --jvmti-step-stress"
504fi
Alex Light43e935d2017-06-19 15:40:40 -0700505if [ "$jvmti_field_stress" = "true" ]; then
506 run_args="${run_args} --no-app-image --jvmti-field-stress"
507fi
Alex Lightb7edcda2017-04-27 13:20:31 -0700508if [ "$jvmti_trace_stress" = "true" ]; then
509 run_args="${run_args} --no-app-image --jvmti-trace-stress"
Alex Light8f2c6d42017-04-10 16:27:35 -0700510fi
Jeff Hao85139a32014-07-23 11:52:52 -0700511if [ "$trace" = "true" ]; then
Andreas Gampe7526d782015-06-22 22:53:45 -0700512 run_args="${run_args} --runtime-option -Xmethod-trace --runtime-option -Xmethod-trace-file-size:2000000"
513 if [ "$trace_stream" = "true" ]; then
514 # Streaming mode uses the file size as the buffer size. So output gets really large. Drop
515 # the ability to analyze the file and just write to /dev/null.
516 run_args="${run_args} --runtime-option -Xmethod-trace-file:/dev/null"
517 # Enable streaming mode.
518 run_args="${run_args} --runtime-option -Xmethod-trace-stream"
519 else
520 run_args="${run_args} --runtime-option -Xmethod-trace-file:${DEX_LOCATION}/trace.bin"
521 fi
522elif [ "$trace_stream" = "true" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700523 err_echo "Cannot use --stream without --trace."
Andreas Gampe7526d782015-06-22 22:53:45 -0700524 exit 1
Jeff Hao85139a32014-07-23 11:52:52 -0700525fi
526
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700527# Most interesting target architecture variables are Makefile variables, not environment variables.
Nicolas Geoffray93d68462018-01-02 11:59:45 +0000528# Try to map the suffix64 flag and what we find in ${ANDROID_PRODUCT_OUT}/data/art-test to an architecture name.
David Brazdil853a4c32015-09-28 16:15:50 +0100529function guess_target_arch_name() {
Nicolas Geoffray93d68462018-01-02 11:59:45 +0000530 grep32bit=`ls ${ANDROID_PRODUCT_OUT}/data/art-test | grep -E '^(arm|x86|mips)$'`
531 grep64bit=`ls ${ANDROID_PRODUCT_OUT}/data/art-test | grep -E '^(arm64|x86_64|mips64)$'`
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700532 if [ "x${suffix64}" = "x64" ]; then
533 target_arch_name=${grep64bit}
534 else
535 target_arch_name=${grep32bit}
536 fi
537}
538
David Brazdil853a4c32015-09-28 16:15:50 +0100539function guess_host_arch_name() {
540 if [ "x${suffix64}" = "x64" ]; then
541 host_arch_name="x86_64"
542 else
543 host_arch_name="x86"
544 fi
545}
546
Alex Lighta59dd802014-07-02 16:28:08 -0700547if [ "$target_mode" = "no" ]; then
548 if [ "$runtime" = "jvm" ]; then
Alex Lighta59dd802014-07-02 16:28:08 -0700549 if [ "$prebuild_mode" = "yes" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700550 err_echo "--prebuild with --jvm is unsupported"
Alex Lighta59dd802014-07-02 16:28:08 -0700551 exit 1;
552 fi
Alex Lighta59dd802014-07-02 16:28:08 -0700553 fi
554fi
555
Alex Light03a112d2014-08-25 13:25:56 -0700556if [ "$have_patchoat" = "no" ]; then
557 run_args="${run_args} --no-patchoat"
558fi
559
560if [ "$have_dex2oat" = "no" ]; then
561 run_args="${run_args} --no-dex2oat"
562fi
563
Jeff Hao201803f2013-11-20 18:11:39 -0800564if [ ! "$runtime" = "jvm" ]; then
565 run_args="${run_args} --lib $lib"
566fi
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700567
Jeff Hao201803f2013-11-20 18:11:39 -0800568if [ "$runtime" = "dalvik" ]; then
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700569 if [ "$target_mode" = "no" ]; then
Nicolas Geoffray93d68462018-01-02 11:59:45 +0000570 framework="${ANDROID_PRODUCT_OUT}/system/framework"
Andreas Gampe50be66f2015-12-28 14:31:06 -0800571 bpath="${framework}/core-libart.jar:${framework}/core-oj.jar:${framework}/conscrypt.jar:${framework}/okhttp.jar:${framework}/bouncycastle.jar:${framework}/ext.jar"
Richard Uhler76f5cb62016-04-04 13:30:16 -0700572 run_args="${run_args} --boot --runtime-option -Xbootclasspath:${bpath}"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700573 else
574 true # defaults to using target BOOTCLASSPATH
575 fi
Jeff Hao201803f2013-11-20 18:11:39 -0800576elif [ "$runtime" = "art" ]; then
577 if [ "$target_mode" = "no" ]; then
David Brazdil853a4c32015-09-28 16:15:50 +0100578 guess_host_arch_name
Richard Uhlerbb00f812017-02-16 14:21:10 +0000579 run_args="${run_args} --boot ${ANDROID_HOST_OUT}/framework/core${image_suffix}${multi_image_suffix}.art"
Colin Crossafd3c9e2016-09-16 13:47:21 -0700580 run_args="${run_args} --runtime-option -Djava.library.path=${ANDROID_HOST_OUT}/lib${suffix64}:${ANDROID_HOST_OUT}/nativetest${suffix64}"
Jeff Hao201803f2013-11-20 18:11:39 -0800581 else
David Brazdil853a4c32015-09-28 16:15:50 +0100582 guess_target_arch_name
Dimitry Ivanov49c2c922017-02-14 11:06:14 -0800583 run_args="${run_args} --runtime-option -Djava.library.path=/data/nativetest${suffix64}/art/${target_arch_name}"
Richard Uhlerbb00f812017-02-16 14:21:10 +0000584 run_args="${run_args} --boot /data/art-test/core${image_suffix}${multi_image_suffix}.art"
Jeff Hao201803f2013-11-20 18:11:39 -0800585 fi
Alex Lighta59dd802014-07-02 16:28:08 -0700586 if [ "$relocate" = "yes" ]; then
587 run_args="${run_args} --relocate"
588 else
589 run_args="${run_args} --no-relocate"
590 fi
Andreas Gampe3f1dc562015-05-18 15:52:22 -0700591elif [ "$runtime" = "jvm" ]; then
592 # TODO: Detect whether the host is 32-bit or 64-bit.
Alex Lightfba89fe2017-01-12 16:11:02 -0800593 run_args="${run_args} --runtime-option -Djava.library.path=${ANDROID_HOST_OUT}/lib64:${ANDROID_HOST_OUT}/nativetest64"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700594fi
595
Alex Light03a112d2014-08-25 13:25:56 -0700596if [ "$have_image" = "no" ]; then
Alex Light1ef4ce82014-08-27 11:13:47 -0700597 if [ "$runtime" != "art" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700598 err_echo "--no-image is only supported on the art runtime"
Alex Light1ef4ce82014-08-27 11:13:47 -0700599 exit 1
600 fi
Alex Light03a112d2014-08-25 13:25:56 -0700601 run_args="${run_args} --no-image"
602fi
603
jeffhao5d1ac922011-09-29 17:41:15 -0700604if [ "$dev_mode" = "yes" -a "$update_mode" = "yes" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700605 err_echo "--dev and --update are mutually exclusive"
606 usage="yes"
607fi
608
609if [ "$dev_mode" = "yes" -a "$quiet" = "yes" ]; then
610 err_echo "--dev and --quiet are mutually exclusive"
jeffhao5d1ac922011-09-29 17:41:15 -0700611 usage="yes"
612fi
613
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700614if [ "$bisection_search" = "yes" -a "$prebuild_mode" = "yes" ]; then
615 err_echo "--bisection-search and --prebuild are mutually exclusive"
616 usage="yes"
617fi
618
619if [ "$bisection_search" = "yes" -a "$have_dex2oat" = "no" ]; then
620 err_echo "--bisection-search and --no-dex2oat are mutually exclusive"
621 usage="yes"
622fi
623
624if [ "$bisection_search" = "yes" -a "$have_patchoat" = "no" ]; then
625 err_echo "--bisection-search and --no-patchoat are mutually exclusive"
626 usage="yes"
627fi
628
jeffhao5d1ac922011-09-29 17:41:15 -0700629if [ "$usage" = "no" ]; then
630 if [ "x$1" = "x" -o "x$1" = "x-" ]; then
631 test_dir=`basename "$oldwd"`
632 else
633 test_dir="$1"
634 fi
635
636 if [ '!' -d "$test_dir" ]; then
637 td2=`echo ${test_dir}-*`
638 if [ '!' -d "$td2" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700639 err_echo "${test_dir}: no such test directory"
jeffhao5d1ac922011-09-29 17:41:15 -0700640 usage="yes"
641 fi
642 test_dir="$td2"
643 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700644 # Shift to get rid of the test name argument. The rest of the arguments
645 # will get passed to the test run.
646 shift
647fi
648
Søren Gjesse620d0a52016-09-19 11:12:51 +0200649# For building with javac and dx always use Java 7. The dx compiler
650# only support byte codes from Java 7 or earlier (class file major
651# version 51 or lower).
652if [ "$USE_JACK" != "true" ] && [ "$NEED_DEX" = "true" ]; then
653 export JAVAC="${JAVAC} -source 1.7 -target 1.7"
654fi
655
jeffhao5d1ac922011-09-29 17:41:15 -0700656if [ "$usage" = "yes" ]; then
657 prog=`basename $prog`
658 (
659 echo "usage:"
660 echo " $prog --help Print this message."
661 echo " $prog [options] [test-name] Run test normally."
662 echo " $prog --dev [options] [test-name] Development mode" \
663 "(dumps to stdout)."
664 echo " $prog --update [options] [test-name] Update mode" \
665 "(replaces expected.txt)."
666 echo ' Omitting the test name or specifying "-" will use the' \
667 "current directory."
668 echo " Runtime Options:"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000669 echo " -O Run non-debug rather than debug build (off by default)."
670 echo " -Xcompiler-option Pass an option to the compiler."
Orion Hodsone1fb77f2017-02-27 13:57:18 +0000671 echo " --build-option Pass an option to the build script."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000672 echo " --runtime-option Pass an option to the runtime."
Mathieu Chartierdcd56c92017-11-20 20:30:24 -0800673 echo " --compact-dex-level Specify a compact dex level to the compiler."
Alex Lightc281ba52017-10-11 11:35:55 -0700674 echo " --debug Wait for the default debugger to attach."
675 echo " --debug-agent <agent-path>"
676 echo " Wait for the given debugger agent to attach. Currently"
677 echo " only supported on host."
678 echo " --debug-wrap-agent use libwrapagentproperties and tools/libjdwp-compat.props"
679 echo " to load the debugger agent specified by --debug-agent."
Alex Light0e151e72017-10-25 10:50:35 -0700680 echo " --with-agent <agent> Run the test with the given agent loaded with -agentpath:"
Nicolas Geoffray43c162f2015-03-09 12:21:26 +0000681 echo " --debuggable Whether to compile Java code for a debugger."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000682 echo " --gdb Run under gdb; incompatible with some tests."
Alex Lightfadfee92015-10-28 09:40:10 -0700683 echo " --gdb-arg Pass an option to gdb."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000684 echo " --build-only Build test files only (off by default)."
Alan Leung0afa07a2017-10-03 16:56:30 -0700685 echo " --build-with-d8 Build test files with javac and d8 (off by default)."
Søren Gjesse620d0a52016-09-19 11:12:51 +0200686 echo " --build-with-javac-dx Build test files with javac and dx (off by default)."
687 echo " --build-with-jack Build test files with jack and jill (on by default)."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000688 echo " --interpreter Enable interpreter only mode (off by default)."
Mathieu Chartiere5f13e52015-02-24 09:37:21 -0800689 echo " --jit Enable jit (off by default)."
Nicolas Geoffray0e071252015-03-21 13:43:15 +0000690 echo " --optimizing Enable optimizing compiler (default)."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000691 echo " --no-verify Turn off verification (on by default)."
Igor Murashkin7617abd2015-07-10 18:27:47 -0700692 echo " --verify-soft-fail Force soft fail verification (off by default)."
693 echo " Verification is enabled if neither --no-verify"
694 echo " nor --verify-soft-fail is specified."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000695 echo " --no-optimize Turn off optimization (on by default)."
696 echo " --no-precise Turn off precise GC (on by default)."
697 echo " --zygote Spawn the process from the Zygote." \
jeffhao5d1ac922011-09-29 17:41:15 -0700698 "If used, then the"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000699 echo " other runtime options are ignored."
700 echo " --no-dex2oat Run as though dex2oat was failing."
701 echo " --no-patchoat Run as though patchoat was failing."
702 echo " --prebuild Run dex2oat on the files before starting test. (default)"
703 echo " --no-prebuild Do not run dex2oat on the files before starting"
704 echo " the test."
Richard Uhler76f5cb62016-04-04 13:30:16 -0700705 echo " --strip-dex Strip the dex files before starting test."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000706 echo " --relocate Force the use of relocating in the test, making"
707 echo " the image and oat files be relocated to a random"
Nicolas Geoffray94e25db2017-01-27 14:54:28 +0000708 echo " address before running."
709 echo " --no-relocate Force the use of no relocating in the test. (default)"
Alex Lightfadfee92015-10-28 09:40:10 -0700710 echo " --image Run the test using a precompiled boot image. (default)"
711 echo " --no-image Run the test without a precompiled boot image."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000712 echo " --host Use the host-mode virtual machine."
713 echo " --invoke-with Pass --invoke-with option to runtime."
714 echo " --dalvik Use Dalvik (off by default)."
715 echo " --jvm Use a host-local RI virtual machine."
Alex Lighteb7c1442015-08-31 13:17:42 -0700716 echo " --use-java-home Use the JAVA_HOME environment variable"
717 echo " to find the java compiler and runtime"
718 echo " (if applicable) to run the test with."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000719 echo " --output-path [path] Location where to store the build" \
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700720 "files."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000721 echo " --64 Run the test in 64-bit mode"
722 echo " --trace Run with method tracing"
Alex Lightfadfee92015-10-28 09:40:10 -0700723 echo " --strace Run with syscall tracing from strace."
Andreas Gampe7526d782015-06-22 22:53:45 -0700724 echo " --stream Run method tracing in streaming mode (requires --trace)"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000725 echo " --gcstress Run with gc stress testing"
726 echo " --gcverify Run with gc verification"
Alex Lightb7edcda2017-04-27 13:20:31 -0700727 echo " --jvmti-trace-stress Run with jvmti method tracing stress testing"
Alex Lightc38c3692017-06-27 15:45:14 -0700728 echo " --jvmti-step-stress Run with jvmti single step stress testing"
Alex Lightb7edcda2017-04-27 13:20:31 -0700729 echo " --jvmti-redefine-stress"
730 echo " Run with jvmti method redefinition stress testing"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000731 echo " --always-clean Delete the test files even if the test fails."
Igor Murashkin05f30e12015-06-10 15:57:17 -0700732 echo " --never-clean Keep the test files even if the test succeeds."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000733 echo " --android-root [path] The path on target for the android root. (/system by default)."
Nicolas Geoffray43c162f2015-03-09 12:21:26 +0000734 echo " --dex2oat-swap Use a dex2oat swap file."
Andreas Gampe4d2ef332015-08-05 09:24:45 -0700735 echo " --instruction-set-features [string]"
736 echo " Set instruction-set-features for compilation."
Jeff Haodcdc85b2015-12-04 14:06:18 -0800737 echo " --multi-image Use a set of images compiled with dex2oat multi-image for"
738 echo " the boot class path."
Alex Lightfadfee92015-10-28 09:40:10 -0700739 echo " --pic-test Compile the test code position independent."
Alex Light91de25f2015-10-28 17:00:06 -0700740 echo " --quiet Don't print anything except failure messages"
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700741 echo " --bisection-search Perform bisection bug search."
Nicolas Geoffrayb0bbe8e2016-11-19 10:42:37 +0000742 echo " --vdex Test using vdex as in input to dex2oat. Only works with --prebuild."
Mathieu Chartier3fceaf52017-01-22 13:33:40 -0800743 echo " --suspend-timeout Change thread suspend timeout ms (default 500000)."
Shubham Ajmera981d99c2017-08-17 14:11:08 -0700744 echo " --dex2oat-jobs Number of dex2oat jobs."
Alex Light91de25f2015-10-28 17:00:06 -0700745 ) 1>&2 # Direct to stderr so usage is not printed if --quiet is set.
jeffhao5d1ac922011-09-29 17:41:15 -0700746 exit 1
747fi
748
749cd "$test_dir"
750test_dir=`pwd`
751
752td_info="${test_dir}/${info}"
753td_expected="${test_dir}/${expected}"
754
Brian Carlstrom22469aa2012-09-07 10:34:57 -0700755if [ ! -r $td_info ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700756 err_echo "${test_dir}: missing file $td_info"
Brian Carlstrom22469aa2012-09-07 10:34:57 -0700757 exit 1
758fi
759
760if [ ! -r $td_expected ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700761 err_echo "${test_dir}: missing file $td_expected"
jeffhao5d1ac922011-09-29 17:41:15 -0700762 exit 1
763fi
764
765# copy the test to a temp dir and run it
766
Elliott Hughes510c8782011-10-06 10:57:34 -0700767echo "${test_dir}: building..." 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700768
769rm -rf "$tmp_dir"
770cp -Rp "$test_dir" "$tmp_dir"
771cd "$tmp_dir"
772
773if [ '!' -r "$build" ]; then
774 cp "${progdir}/etc/default-build" build
Zheng Xuc6667102015-05-15 16:08:45 +0800775else
776 cp "${progdir}/etc/default-build" .
jeffhao5d1ac922011-09-29 17:41:15 -0700777fi
778
779if [ '!' -r "$run" ]; then
780 cp "${progdir}/etc/default-run" run
Zheng Xuc6667102015-05-15 16:08:45 +0800781else
782 cp "${progdir}/etc/default-run" .
jeffhao5d1ac922011-09-29 17:41:15 -0700783fi
784
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700785if [ '!' -r "$check_cmd" ]; then
786 cp "${progdir}/etc/default-check" check
Zheng Xuc6667102015-05-15 16:08:45 +0800787else
788 cp "${progdir}/etc/default-check" .
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700789fi
790
jeffhao5d1ac922011-09-29 17:41:15 -0700791chmod 755 "$build"
792chmod 755 "$run"
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700793chmod 755 "$check_cmd"
jeffhao5d1ac922011-09-29 17:41:15 -0700794
Elliott Hughes8cbc8bc2011-10-04 11:19:45 -0700795export TEST_NAME=`basename ${test_dir}`
796
Nicolas Geoffray1949baf2017-10-17 12:14:53 +0000797# Tests named '<number>-checker-*' will also have their CFGs verified with
798# Checker when compiled with Optimizing on host.
799if [[ "$TEST_NAME" =~ ^[0-9]+-checker- ]]; then
800 if [ "$runtime" = "art" -a "$image_suffix" = "" ]; then
801 # In no-prebuild or no-image mode, the compiler only quickens so disable the checker.
802 if [ "$prebuild_mode" = "yes" -a "$have_image" = "yes" ]; then
803 run_checker="yes"
804
805 if [ "$target_mode" = "no" ]; then
806 cfg_output_dir="$tmp_dir"
807 checker_args="--arch=${host_arch_name^^}"
808 else
809 cfg_output_dir="$DEX_LOCATION"
810 checker_args="--arch=${target_arch_name^^}"
811 fi
812
813 if [ "$debuggable" = "yes" ]; then
814 checker_args="$checker_args --debuggable"
815 fi
816
817 run_args="${run_args} -Xcompiler-option --dump-cfg=$cfg_output_dir/$cfg_output \
818 -Xcompiler-option -j1"
819 fi
820 fi
821fi
822
Mathieu Chartier031768a2015-08-27 10:25:02 -0700823 run_args="${run_args} --testlib ${testlib}"
Mathieu Chartier031768a2015-08-27 10:25:02 -0700824
Richard Uhler020c0f32017-03-14 16:23:17 +0000825# To cause tests to fail fast, limit the file sizes created by dx, dex2oat and
826# ART output to approximately 128MB. This should be more than sufficient
827# for any test while still catching cases of runaway output.
828# Set a hard limit to encourage ART developers to increase the ulimit here if
829# needed to support a test case rather than resetting the limit in the run
830# script for the particular test in question.
Orion Hodsonbd328d32017-03-24 11:24:10 +0000831if ! ulimit -f 128000; then
Richard Uhler020c0f32017-03-14 16:23:17 +0000832 err_echo "ulimit file size setting failed"
Ian Rogers997f0f92014-06-21 22:58:05 -0700833fi
834
Igor Murashkin2a337752017-06-16 14:34:40 +0000835if [[ "$target_mode" == "yes" ]]; then
836 build_args="$build_args --target"
837else
838 build_args="$build_args --host"
839fi
840
841if [[ "$dev_mode" == "yes" ]]; then
842 build_args="$build_args --dev"
843fi
844
jeffhao5d1ac922011-09-29 17:41:15 -0700845good="no"
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000846good_build="yes"
847good_run="yes"
Alex Light77fee872017-09-05 14:51:49 -0700848export TEST_RUNTIME="${runtime}"
jeffhao5d1ac922011-09-29 17:41:15 -0700849if [ "$dev_mode" = "yes" ]; then
David Brazdil4846d132015-01-15 19:07:08 +0000850 "./${build}" $build_args 2>&1
Elliott Hughes7ab3a2a2012-06-18 16:34:20 -0700851 build_exit="$?"
852 echo "build exit status: $build_exit" 1>&2
853 if [ "$build_exit" = '0' ]; then
Elliott Hughes2bfc6732012-11-27 20:40:51 -0800854 echo "${test_dir}: running..." 1>&2
855 "./${run}" $run_args "$@" 2>&1
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700856 run_exit="$?"
Calin Juravle3cf48772015-01-26 16:47:33 +0000857
Brian Carlstrom700c8d32012-11-05 10:42:02 -0800858 if [ "$run_exit" = "0" ]; then
Calin Juravle3cf48772015-01-26 16:47:33 +0000859 if [ "$run_checker" = "yes" ]; then
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100860 if [ "$target_mode" = "yes" ]; then
861 adb pull $cfg_output_dir/$cfg_output &> /dev/null
862 fi
David Brazdil5cc343d2015-10-08 11:35:32 +0100863 "$checker" $checker_args "$cfg_output" "$tmp_dir" 2>&1
Calin Juravle3cf48772015-01-26 16:47:33 +0000864 checker_exit="$?"
865 if [ "$checker_exit" = "0" ]; then
866 good="yes"
867 fi
Alex Light91de25f2015-10-28 17:00:06 -0700868 err_echo "checker exit status: $checker_exit"
Calin Juravle3cf48772015-01-26 16:47:33 +0000869 else
870 good="yes"
871 fi
Brian Carlstrom700c8d32012-11-05 10:42:02 -0800872 fi
Calin Juravle3cf48772015-01-26 16:47:33 +0000873 echo "run exit status: $run_exit" 1>&2
Elliott Hughes7ab3a2a2012-06-18 16:34:20 -0700874 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700875elif [ "$update_mode" = "yes" ]; then
David Brazdil4846d132015-01-15 19:07:08 +0000876 "./${build}" $build_args >"$build_output" 2>&1
jeffhao5d1ac922011-09-29 17:41:15 -0700877 build_exit="$?"
878 if [ "$build_exit" = '0' ]; then
Elliott Hughes2bfc6732012-11-27 20:40:51 -0800879 echo "${test_dir}: running..." 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700880 "./${run}" $run_args "$@" >"$output" 2>&1
David Brazdil4846d132015-01-15 19:07:08 +0000881 if [ "$run_checker" = "yes" ]; then
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100882 if [ "$target_mode" = "yes" ]; then
883 adb pull $cfg_output_dir/$cfg_output &> /dev/null
884 fi
David Brazdil5cc343d2015-10-08 11:35:32 +0100885 "$checker" -q $checker_args "$cfg_output" "$tmp_dir" >> "$output" 2>&1
David Brazdil4846d132015-01-15 19:07:08 +0000886 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700887 sed -e 's/[[:cntrl:]]$//g' < "$output" >"${td_expected}"
888 good="yes"
889 else
Alex Light91de25f2015-10-28 17:00:06 -0700890 cat "$build_output" 1>&${real_stderr} 1>&2
891 err_echo "build exit status: $build_exit"
jeffhao5d1ac922011-09-29 17:41:15 -0700892 fi
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700893elif [ "$build_only" = "yes" ]; then
894 good="yes"
David Brazdil4846d132015-01-15 19:07:08 +0000895 "./${build}" $build_args >"$build_output" 2>&1
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700896 build_exit="$?"
897 if [ "$build_exit" '!=' '0' ]; then
898 cp "$build_output" "$output"
899 echo "build exit status: $build_exit" >>"$output"
900 diff --strip-trailing-cr -q "$expected" "$output" >/dev/null
901 if [ "$?" '!=' "0" ]; then
902 good="no"
Alex Light91de25f2015-10-28 17:00:06 -0700903 err_echo "BUILD FAILED For ${TEST_NAME}"
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700904 fi
905 fi
Tsu Chiang Chuang379e2f52013-08-20 12:24:52 -0700906 # Clean up extraneous files that are not used by tests.
Tsu Chiang Chuang0160d992013-09-13 14:17:42 -0700907 find $tmp_dir -mindepth 1 ! -regex ".*/\(.*jar\|$output\|$expected\)" | xargs rm -rf
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700908 exit 0
jeffhao5d1ac922011-09-29 17:41:15 -0700909else
David Brazdil4846d132015-01-15 19:07:08 +0000910 "./${build}" $build_args >"$build_output" 2>&1
jeffhao5d1ac922011-09-29 17:41:15 -0700911 build_exit="$?"
912 if [ "$build_exit" = '0' ]; then
Elliott Hughes2bfc6732012-11-27 20:40:51 -0800913 echo "${test_dir}: running..." 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700914 "./${run}" $run_args "$@" >"$output" 2>&1
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000915 run_exit="$?"
916 if [ "$run_exit" != "0" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700917 err_echo "run exit status: $run_exit"
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000918 good_run="no"
David Brazdil4846d132015-01-15 19:07:08 +0000919 elif [ "$run_checker" = "yes" ]; then
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100920 if [ "$target_mode" = "yes" ]; then
921 adb pull $cfg_output_dir/$cfg_output &> /dev/null
922 fi
David Brazdil5cc343d2015-10-08 11:35:32 +0100923 "$checker" -q $checker_args "$cfg_output" "$tmp_dir" >> "$output" 2>&1
David Brazdil4846d132015-01-15 19:07:08 +0000924 checker_exit="$?"
925 if [ "$checker_exit" != "0" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700926 err_echo "checker exit status: $checker_exit"
David Brazdil4846d132015-01-15 19:07:08 +0000927 good_run="no"
928 else
929 good_run="yes"
930 fi
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000931 else
932 good_run="yes"
933 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700934 else
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000935 good_build="no"
jeffhao5d1ac922011-09-29 17:41:15 -0700936 cp "$build_output" "$output"
Andreas Gampef6930a82014-10-21 09:33:08 -0700937 echo "Failed to build in tmpdir=${tmp_dir} from oldwd=${oldwd} and cwd=`pwd`" >> "$output"
938 echo "Non-canonical tmpdir was ${noncanonical_tmp_dir}" >> "$output"
Ian Rogersd9ad27d2014-10-27 13:48:21 -0700939 echo "Args: ${args}" >> "$output"
Andreas Gampef6930a82014-10-21 09:33:08 -0700940 echo "build exit status: $build_exit" >> "$output"
Andreas Gampe5c114902014-10-27 17:03:58 -0700941 max_name_length=$(getconf NAME_MAX ${tmp_dir})
942 echo "Max filename (NAME_MAX): ${max_name_length}" >> "$output"
943 max_path_length=$(getconf PATH_MAX ${tmp_dir})
Andreas Gampe602fbcd2014-10-27 17:06:29 -0700944 echo "Max pathlength (PATH_MAX): ${max_path_length}" >> "$output"
jeffhao5d1ac922011-09-29 17:41:15 -0700945 fi
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700946 ./$check_cmd "$expected" "$output"
jeffhao5d1ac922011-09-29 17:41:15 -0700947 if [ "$?" = "0" ]; then
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000948 if [ "$good_build" = "no" -o "$good_run" = "yes" ]; then
949 # output == expected
950 good="yes"
951 echo "${test_dir}: succeeded!" 1>&2
952 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700953 fi
954fi
955
jeffhao5d1ac922011-09-29 17:41:15 -0700956(
Alex Lightbfac14a2014-07-30 09:41:21 -0700957 if [ "$good" != "yes" -a "$update_mode" != "yes" ]; then
jeffhao5d1ac922011-09-29 17:41:15 -0700958 echo "${test_dir}: FAILED!"
959 echo ' '
960 echo '#################### info'
961 cat "${td_info}" | sed 's/^/# /g'
962 echo '#################### diffs'
Hiroshi Yamauchid630fd62015-09-04 12:52:03 -0700963 diff --strip-trailing-cr -u "$expected" "$output" | tail -n 3000
jeffhao5d1ac922011-09-29 17:41:15 -0700964 echo '####################'
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700965 if [ "$strace" = "yes" ]; then
966 echo '#################### strace output'
Hiroshi Yamauchid630fd62015-09-04 12:52:03 -0700967 tail -n 3000 "$tmp_dir/$strace_output"
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700968 echo '####################'
969 fi
Andreas Gampee79ca192017-07-31 10:30:16 -0700970 if [ "x$target_mode" = "xno" -a "x$SANITIZE_HOST" = "xaddress" ]; then
971 # Run the stack script to symbolize any ASAN aborts on the host for SANITIZE_HOST. The
972 # tools used by the given ABI work for both x86 and x86-64.
973 echo "ABI: 'x86_64'" | cat - "$output" | $ANDROID_BUILD_TOP/development/scripts/stack | tail -n 3000
974 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700975 echo ' '
976 fi
Alex Lightbfac14a2014-07-30 09:41:21 -0700977
Alex Light91de25f2015-10-28 17:00:06 -0700978) 2>&${real_stderr} 1>&2
Alex Lightbfac14a2014-07-30 09:41:21 -0700979
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700980# Attempt bisection only if the test failed.
981if [ "$bisection_search" = "yes" -a "$good" != "yes" ]; then
982 # Bisecting works by skipping different optimization passes which breaks checker assertions.
983 if [ "$run_checker" == "yes" ]; then
984 echo "${test_dir}: not bisecting, checker test." 1>&2
985 else
986 # Increase file size limit, bisection search can generate large logfiles.
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700987 echo "${test_dir}: bisecting..." 1>&2
988 cwd=`pwd`
989 maybe_device_mode=""
990 raw_cmd=""
991 if [ "$target_mode" = "yes" ]; then
992 # Produce cmdline.sh in $DEX_LOCATION. "$@" is passed as a runtime option
993 # so that cmdline.sh forwards its arguments to dalvikvm. invoke-with is set
994 # to exec in order to preserve pid when calling dalvikvm. This is required
995 # for bisection search to correctly retrieve logs from device.
996 "./${run}" $run_args --runtime-option '"$@"' --invoke-with exec --dry-run "$@" &> /dev/null
997 adb shell chmod u+x "$DEX_LOCATION/cmdline.sh"
998 maybe_device_mode="--device"
999 raw_cmd="$DEX_LOCATION/cmdline.sh"
1000 else
1001 raw_cmd="$cwd/${run} --external-log-tags $run_args $@"
1002 fi
1003 $ANDROID_BUILD_TOP/art/tools/bisection_search/bisection_search.py \
1004 $maybe_device_mode \
1005 --raw-cmd="$raw_cmd" \
1006 --check-script="$cwd/check" \
1007 --expected-output="$cwd/expected.txt" \
Wojciech Staszkiewicz0c883832016-09-26 17:51:52 -07001008 --logfile="$cwd/bisection_log.txt" \
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -07001009 --timeout=300
1010 fi
1011fi
1012
Alex Lightbfac14a2014-07-30 09:41:21 -07001013# Clean up test files.
Igor Murashkin05f30e12015-06-10 15:57:17 -07001014if [ "$always_clean" = "yes" -o "$good" = "yes" ] && [ "$never_clean" = "no" ]; then
Alex Lightbfac14a2014-07-30 09:41:21 -07001015 cd "$oldwd"
1016 rm -rf "$tmp_dir"
1017 if [ "$target_mode" = "yes" -a "$build_exit" = "0" ]; then
1018 adb shell rm -rf $DEX_LOCATION
1019 fi
1020 if [ "$good" = "yes" ]; then
1021 exit 0
1022 fi
1023fi
1024
1025
1026(
1027 if [ "$always_clean" = "yes" ]; then
1028 echo "${TEST_NAME} files deleted from host "
1029 if [ "$target_mode" == "yes" ]; then
1030 echo "and from target"
1031 fi
1032 else
1033 echo "${TEST_NAME} files left in ${tmp_dir} on host"
1034 if [ "$target_mode" == "yes" ]; then
1035 echo "and in ${DEX_LOCATION} on target"
1036 fi
Brian Carlstrom105215d2012-06-14 12:50:44 -07001037 fi
1038
Alex Light91de25f2015-10-28 17:00:06 -07001039) 2>&${real_stderr} 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -07001040
Alex Light6a870fa2016-05-31 16:36:19 -07001041if [ "$never_clean" = "yes" ] && [ "$good" = "yes" ]; then
1042 exit 0
1043else
1044 exit 1
1045fi